=== debian/changelog ===
wlmaker (0.3-2build2) plucky; urgency=medium

  * Rebuild against latest wlroots

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 08 Nov 2024 07:29:16 -0500

wlmaker (0.3-2build1) plucky; urgency=medium

  * No-change rebuild for libwlroots-0.18

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 03 Nov 2024 21:55:40 +0000

wlmaker (0.3-2) unstable; urgency=medium

  * d/control: update Vcs fields.
  * d/docs: add more upstream docs.
  * d/examples: added.
  * d/clean: added.
  * d/install: install to wayland-session.4

 -- Alex Myczko <tar@debian.org>  Fri, 30 Aug 2024 07:32:48 +0000

wlmaker (0.3-1) unstable; urgency=medium

  * Initial release. (Closes: #1074240)

 -- Alex Myczko <tar@debian.org>  Thu, 04 Jul 2024 21:50:36 +0000
