=== share/CMakeLists.txt ===
--- 
+++ 
@@ -32,3 +32,11 @@
 INSTALL(
   FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.desktop
   TYPE DATA)
+
+CONFIGURE_FILE(
+  ${CMAKE_CURRENT_SOURCE_DIR}/wlmclock.desktop.in
+  ${CMAKE_CURRENT_BINARY_DIR}/wlmclock.desktop
+  @ONLY)
+INSTALL(
+  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmclock.desktop
+  TYPE DATA)
