=== src/CMakeLists.txt ===
--- 
+++ 
@@ -13,13 +13,13 @@
 # limitations under the License.
 
 CMAKE_MINIMUM_REQUIRED(VERSION 3.13)
-INCLUDE(EmbedBinary)
 
 SET(PUBLIC_HEADER_FILES
   action.h
   background.h
   clip.h
   config.h
+  corner.h
   cursor.h
   dock.h
   icon_manager.h
@@ -48,6 +48,7 @@
   background.c
   clip.c
   config.c
+  corner.c
   cursor.c
   dock.c
   icon_manager.c
@@ -76,21 +77,6 @@
   VERSION 1.0
   PUBLIC_HEADER "${PUBLIC_HEADER_FILES}")
 
-EmbedBinary_ADD_LIBRARY(
-  embedded_configuration
-  "default_configuration"
-  "${PROJECT_SOURCE_DIR}/etc/wlmaker.plist")
-
-EmbedBinary_ADD_LIBRARY(
-  embedded_state
-  "default_state"
-  "${PROJECT_SOURCE_DIR}/etc/wlmaker-state.plist")
-
-EmbedBinary_ADD_LIBRARY(
-  embedded_style
-  "style_default"
-  "${PROJECT_SOURCE_DIR}/etc/style-default.plist")
-
 ADD_DEPENDENCIES(
   wlmaker_lib
   protocol_headers
@@ -117,11 +103,12 @@
   PkgConfig::XKBCOMMON)
 TARGET_INCLUDE_DIRECTORIES(
   wlmaker_lib PUBLIC
+  # Keep wlroots first -- multiple versions may interfere (#117).
+  ${WLROOTS_INCLUDE_DIRS}
   ${PROJECT_BINARY_DIR}/third_party/protocols
   ${PROJECT_BINARY_DIR}/protocols
   ${CAIRO_INCLUDE_DIRS}
   ${WAYLAND_INCLUDE_DIRS}
-  ${WLROOTS_INCLUDE_DIRS}
   ${XCB_INCLUDE_DIRS}
   ${XKBCOMMON_INCLUDE_DIRS}
 )
