=== src/toolkit/CMakeLists.txt ===
--- 
+++ 
@@ -30,13 +30,17 @@
   input.h
   layer.h
   lock.h
+  menu.h
+  menu_item.h
   panel.h
   popup.h
+  popup_menu.h
   primitives.h
   rectangle.h
   resizebar.h
   resizebar_area.h
   root.h
+  simple_menu_item.h
   style.h
   surface.h
   tile.h
@@ -65,13 +69,17 @@
   image.c
   layer.c
   lock.c
+  menu.c
+  menu_item.c
   panel.c
   popup.c
+  popup_menu.c
   primitives.c
   rectangle.c
   resizebar.c
   resizebar_area.c
   root.c
+  simple_menu_item.c
   style.c
   surface.c
   tile.c
@@ -83,13 +91,14 @@
   workspace.c
 )
 TARGET_INCLUDE_DIRECTORIES(
-  toolkit PUBLIC
-  ${CMAKE_CURRENT_SOURCE_DIR}/..
-  ${WLROOTS_INCLUDE_DIRS})
+  toolkit PRIVATE
+  ${WLROOTS_INCLUDE_DIRS}
+)
 SET_TARGET_PROPERTIES(
   toolkit PROPERTIES
   VERSION 1.0
-  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}")
+  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}"
+)
 
 TARGET_COMPILE_OPTIONS(
   toolkit PRIVATE
