=== debian/changelog ===
wlmaker (0.4.1-2) unstable; urgency=medium

  * d/control: drop build-depends libwlroots-dev.

 -- Alex Myczko <tar@debian.org>  Mon, 18 Nov 2024 09:55:23 +0000

wlmaker (0.4.1-1) unstable; urgency=medium

  * New upstream version.
  * d/control: add libwlroots-0.18-dev to build-depends.

 -- Alex Myczko <tar@debian.org>  Mon, 11 Nov 2024 09:31:26 +0000
