=== debian/control ===
Source: wlmaker
Section: gnustep
Priority: optional
Maintainer: Debian GNUstep maintainers <pkg-gnustep-maintainers@lists.alioth.debian.org>
Uploaders: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 bison,
 cmake,
 flex,
 libwayland-dev,
 libcairo2-dev,
 wayland-protocols,
 libwlroots-0.18-dev,
 libncurses-dev,
# plantuml,
 libwayland-bin,
Standards-Version: 4.7.0
Homepage: https://github.com/phkaeser/wlmaker
Vcs-Browser: https://salsa.debian.org/gnustep-team/wlmaker
Vcs-Git: https://salsa.debian.org/gnustep-team/wlmaker.git

Package: wlmaker
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Wayland compositor inspired by Window Maker
 This is a Wayland compositor inspired by Window Maker.
  - Compositor for windows in stacking mode.
  - Supports multiple workspaces.
  - Appearance inspired by Window Maker, following the look and feel of
    NeXTSTEP.
  - Easy to use, lightweight, low gimmicks and fast.
  - Dock and clip, to be extended for dockable apps.
